package pacman.util;
import java.util.LinkedList;

/**
 * This buffer is used to remember direction changes requested by the user for
 * some game turns. If a direction change was requested too early (move not
 * possible yet, because the crossing has not been reached) the direction change
 * can be retired in the next steps. The size parameter of the constructor
 * contols how long the user input will be remembered. If another direction is
 * set, all previous directions will be forgotten.
 * 
 * By default the buffer will return the neutral Direction.none direction. If
 * another direction is set, the buffer will return this direction for the next
 * n calls to getRequestedDirection(), where n = size. When a new direction is
 * set, all previously set directions are forgotten.
 * 
 */
public class RequestedDirectionBuffer {

    private final int f014;
    private final LinkedList<Direction> f114;

    public RequestedDirectionBuffer(int v0) {
        super();
        this.f014 = v0;
        f114 = new LinkedList<Direction>();
        m214(Direction.f41);
    }

    /**
     * Get the currently requested direction.
     * 
     * @return the currently requested direction.
     */
    public Direction m014() {
        final Direction v1;
		v1 = f114.poll();
        f114.add(Direction.f41);
        return v1;
    }

    /**
     * Set the requested direction
     * 
     * @param v2
     *            the requested direction
     */
    public void m114(Direction v2) {
        m214(v2);
    }

    /**
     * Fill the queue with a direction
     * 
     * @param v3
     *            the direction.
     */
    private void m214(Direction v3) {
        f114.clear();
        int v4;
		for (v4 = 0; v4 < f014; v4++) {
            f114.add(v3);
        }
    }
}
