package pacman.ai;
import pacman.actors.Actor;
import pacman.map.Map;

/**
 * A heuristic that uses the tile that is closest to the target as the next best
 * tile.
 * 
 * @author Kevin Glass
 */
public class AStarHeuristic {

    /**
     * Get the additional heuristic cost of the given tile. This controls the
     * order in which tiles are searched while attempting to find a path to the
     * target location. The lower the cost the more likely the tile will be
     * searched.
     * 
     * @param v0
     *            The map on which the path is being found
     * @param v1
     *            The entity that is moving along the path
     * @param v2
     *            The x coordinate of the tile being evaluated
     * @param v3
     *            The y coordinate of the tile being evaluated
     * @param v4
     *            The x coordinate of the target location
     * @param v5
     *            Teh y coordinate of the target location
     * @return The cost associated with the given tile
     */
    public float m016(Map v0, Actor v1, int v2, int v3, int v4, int v5) {
        final float v6;
		v6 = v4 - v2;
        final float v7;
		v7 = v5 - v3;

        final float v8;
		v8 = (float) (Math.sqrt((v6 * v6) + (v7 * v7)));

        return v8;
    }

}
