package pacman.util;
import java.util.LinkedList;

/**
 * This buffer is used to remember direction changes requested by the user for
 * some game turns. If a direction change was requested too early (move not
 * possible yet, because the crossing has not been reached) the direction change
 * can be retired in the next steps. The size parameter of the constructor
 * contols how long the user input will be remembered. If another direction is
 * set, all previous directions will be forgotten.
 * 
 * By default the buffer will return the neutral Direction.none direction. If
 * another direction is set, the buffer will return this direction for the next
 * n calls to getRequestedDirection(), where n = size. When a new direction is
 * set, all previously set directions are forgotten.
 * 
 */
public class RequestedDirectionBuffer {

    private final int f011;
    private final LinkedList<Direction> f111;

    public RequestedDirectionBuffer(int v0) {
        super();
        this.f011 = v0;
        f111 = new LinkedList<Direction>();
        m211(Direction.f40);
    }

    /**
     * Get the currently requested direction.
     * 
     * @return the currently requested direction.
     */
    public Direction m011() {
        final Direction v1;
		v1 = f111.poll();
        f111.add(Direction.f40);
        return v1;
    }

    /**
     * Set the requested direction
     * 
     * @param v2
     *            the requested direction
     */
    public void m111(Direction v2) {
        m211(v2);
    }

    /**
     * Fill the queue with a direction
     * 
     * @param v3
     *            the direction.
     */
    private void m211(Direction v3) {
        f111.clear();
        int v4;
		v4 = 0;
		while (v4 < f011) {
			f111.add(v3);
			v4++;
		}
    }
}
