package pacman.state;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.event.KeyEvent;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import pacman.game.Game;

/**
 * StateScoreboard is a mode of the program that allows the user to view (and
 * sometimes modify) scores set in StateGame StateScoreboard is a subclass of
 * State
 * 
 * @author Ramsey Kant
 */
public class StateScoreboard extends State {

    private String[] f017;
    private int[] f117;
    private int f217;

    /**
     * Class Constructor
     * 
     * @param v0
     *            Reference to the Game class
     */
    public StateScoreboard(Game v0) {
        super(v0);
    }

    // Public Functions

    /**
     * Setup the scoreboard by loading the current score file
     * 
     * @see State#m18()
     */
    @Override
    public void m18() {
        // Only the top 10 scores will be displayed
        f017 = new String[10];
        f117 = new int[10];
        f217 = 0;

        // Read in the scores
        // readScores();
    }

    /**
     * Cleanup objects and write back the scores
     * 
     * @see State#m38()
     */
    @Override
    public void m38() {
        // saveScores();
    }

    /**
     * Render the Scoreboard and perform any updates
     */
    @Override
    public void m28() {
        final Graphics2D v1;
		v1 = f68.m220();

        // Draw title
        v1.setColor(Color.YELLOW);
        v1.setFont(new Font("Comic Sans MS", Font.BOLD, 72));
        v1.fillArc(156, 92, 100, 100, 35, 270); // First pacman
        v1.drawString("Scores", 450, 180);
        v1.fillArc(960, 92, 100, 100, 35, 270);
        v1.fillRect(150, 200, 910, 5);

        v1.setFont(new Font("Comic Sans MS", Font.BOLD, 24));

        int v2;
		// Draw scores
        for (v2 = 0; v2 < f017.length; v2 = v2 + 1) {
            if (f017[v2] == null) {
                continue;
            }

            v1.drawString(f017[v2], 150, 210);
            v1.drawString(f117[v2] + " ", 960, 210);
        }
    }

    /**
     * Output names and corresponding scores to the pacman.scores file
     */
    public void m017() {
        FileOutputStream v3;
        DataOutputStream v4;

        try {
            v3 = new FileOutputStream("pacman.scores");
            v4 = new DataOutputStream(v3);

            // Write the score file magic
            v4.writeUTF("RKPACSCORES");

            // Write # of scores in the file, then the actual scores
            v4.writeInt(f217);
            int v5;
			for (v5 = 0; v5 < f217; v5 = v5 + 1) {
                if (f017[v5] == null) {
                    break;
                }
                v4.writeUTF(f017[v5]);
                v4.writeInt(f117[v5]);
            }

            v4.close();
            v3.close();
        } catch (final IOException v6) {
            System.out.println("Failed to write score file: " + v6.getMessage());
        }
    }

    /**
     * Populate names and scores from the pacman.scores file
     */
    public void m117() {
        FileInputStream v7;
        DataInputStream v8;

        try {
            v7 = new FileInputStream("pacman.scores");
            v8 = new DataInputStream(v7);

            // Check for the magic
            if (!v8.readUTF().equals("RKPACSCORES")) {
                System.out.println("Not a score file!");
                return;
            }

            // Read in scores
            f217 = v8.readInt();
            if (f217 > 10) {
                f217 = 10;
            }
            int v9;
			for (v9 = 0; v9 < f217; v9 = v9 + 1) {
                f017[v9] = v8.readUTF();
                f117[v9] = v8.readInt();
            }

            v8.close();
            v7.close();
        } catch (final IOException v10) {
            System.out.println("Failed to read score file: " + v10.getMessage());
        }
    }

    // Input functions

    /**
     * Process input on the scoreboard (exit)
     * 
     * @see java.awt.event.KeyListener#keyPressed(java.awt.event.KeyEvent)
     */
    @Override
    public void keyPressed(KeyEvent v11) {
        switch (v11.getKeyCode()) {
            case KeyEvent.VK_0:
                f68.m720(f08);
                break;
            default:
                break;
        }
    }

}
