import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class checkResult {
	
	public static HashMap<Integer, String> fileMap = null;

	public static void main(String argv[]) {

		ArrayList<String> obfuscationList = new ArrayList<String>();
		
		obfuscationList.add("contraction");
		obfuscationList.add("contractionLoop");
		obfuscationList.add("expansion");
		obfuscationList.add("expansionContraction");
		obfuscationList.add("expansionContractionLoop");
		obfuscationList.add("expansionLoop");
		obfuscationList.add("loop");
		obfuscationList.add("original");
		obfuscationList.add("renaming");
		obfuscationList.add("renamingContraction");
		obfuscationList.add("renamingContractionLoop");
		obfuscationList.add("renamingExpansion");
		obfuscationList.add("renamingExpansionContraction");
		obfuscationList.add("renamingExpansionContractionLoop");
		obfuscationList.add("renamingExpansionLoop");
		obfuscationList.add("renamingLoop");
		
		// create HashMap for FileIDs
		for (String obfuscation : obfuscationList) {
			
//			System.out.println("Results for " + obfuscation + ":");
			
			fileMap = createFileList(openFile("c:\\Detection\\DetectionPairsScorpio\\"+  obfuscation + "\\pdgResult.xml", "FILE"));
			int[] cross = analyzeCross(openFile("c:\\Detection\\DetectionPairsScorpio\\"+  obfuscation + "\\pdgResult.xml", "CLONESET"));
			int[] complete = analyzeComplete(openFile("c:\\Detection\\DetectionPairsScorpio\\"+  obfuscation + "\\pdgResult.xml", "CLONESET"));
			
			System.out.println(obfuscation + " & " + complete[0] + " & " + complete[1] + " & " + cross[0] + " & " + cross[1] + " \\\\");
		}
	} 
	
	public static int[] analyzeCross(NodeList nList) {
		
		int sizeOfClones = 0;
		int amountOfCloneSets = 0;
		
		int cloneSet = 0;
		while (cloneSet < nList.getLength()) {
			
			if(isCrossProjectClone(nList.item(cloneSet))) {
				amountOfCloneSets++;
				int numberOfClones = 0;
				int sizeOfClone = 0;
				
				int i = 0;
				Node node = null;
//				while(!nodeStr.equals("[CLONE: null]")) {
//					nodeStr = nList.item(cloneSet).getChildNodes().item(i).toString();
//					node = nList.item(cloneSet).getChildNodes().item(i++);
//				}
				
				while(i < nList.item(cloneSet).getChildNodes().getLength())  {
					if(nList.item(cloneSet).getChildNodes().item(i).toString().equals("[CLONE: null]")) {
							node = nList.item(cloneSet).getChildNodes().item(i);
							numberOfClones++;
					}
					i++;
				}
		
				int j = 0;
				while(j < node.getChildNodes().getLength()) {
					if(node.getChildNodes().item(j).toString().equals("[ELEMENT: null]"))
						sizeOfClone++;
					j++;
				}	
				
				// Anzahl der Clone in der ClonKlasse mal deren Anzahl der Elemente
				sizeOfClones += numberOfClones * sizeOfClone;
			}
			cloneSet++;
		}
		
//		System.out.println("Amount of Code Clones: " + amountOfCloneSets);
//		System.out.println("Size of Code Clones: " + sizeOfClones);
		
		int[] result = {amountOfCloneSets, sizeOfClones};
		
		return result;
	}

	public static int[] analyzeComplete(NodeList nList) {

		int sizeOfClones = 0;
		int amountOfCloneSets = 0;
		
		int cloneSet = 0;
		while (cloneSet < nList.getLength()) {
			
			amountOfCloneSets++;
			int numberOfClones = 0;
			int sizeOfClone = 0;
				
			int i = 0;
			Node node = null;
			while(i < nList.item(cloneSet).getChildNodes().getLength())  {
				if(nList.item(cloneSet).getChildNodes().item(i).toString().equals("[CLONE: null]")) {
					node = nList.item(cloneSet).getChildNodes().item(i);
					numberOfClones++;
				}
				i++;
			}
		
			int j = 0;
			while(j < node.getChildNodes().getLength()) {
				if(node.getChildNodes().item(j).toString().equals("[ELEMENT: null]"))
					sizeOfClone++;
				j++;
			}	
			// Anzahl der Clone in der ClonKlasse mal deren Anzahl der Elemente
			sizeOfClones += numberOfClones * sizeOfClone;
			cloneSet++;
		}
		
//		System.out.println("Amount of Code Clones: " + amountOfCloneSets);
//		System.out.println("Size of Code Clones: " + sizeOfClones);
		
		int[] result = {amountOfCloneSets, sizeOfClones};
		
		return result;
	}
	
	public static boolean isCrossProjectClone(Node cloneSet) {
		ArrayList<String> fileIdList = new ArrayList<String>();
		
		//Jeden Clone untersuchen und OWNERFILEID vom ersten ELEMENT speichern (FILEID generell gleich innerhalb eines Clones)
		int clone = 0;
		NodeList cloneSetChilds = cloneSet.getChildNodes();
		while(clone < cloneSetChilds.getLength()) {
			
			//Jedes Element durchsuchen
			int element = 0;
			NodeList cloneChilds = cloneSetChilds.item(clone).getChildNodes();
			while(element < cloneChilds.getLength()) {
				
				//Kinder von Element untersuchen bis FIlEID gefunden
				int elementChild = 0;
				NodeList elementChilds = cloneChilds.item(element).getChildNodes();
				while(elementChild < elementChilds.getLength()) {
					Node elementChildNode = elementChilds.item(elementChild++);
					
					//fge FileID hinzu
					if((elementChildNode != null) && (elementChildNode.toString().equals("[OWNERFILEID: null]"))) {
						String fileLoc = fileMap.get(Integer.valueOf(elementChildNode.getTextContent()));
						if (!fileIdList.contains(fileLoc))
							fileIdList.add(fileLoc);
					}
				}
					
				
				element++;
			}
			
			clone++;
		}
		
		//Vergleiche enthaltene FileIDs ob mindestens ein Standard und eine Obfuscation drin ist
		boolean original = false;
		boolean obfuscated = false;
		for(String file : fileIdList) {
			if (file.contains("Obf"))
				obfuscated = true;
			else
				original = true;
		}
		
		if (obfuscated && original)
			return true;
		else
			return false;
	}
	
	public static NodeList openFile(String fileName, String cloneSet) {
		try {
		File fXmlFile = new File(fileName);
		DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder dBuilder;
		dBuilder = dbFactory.newDocumentBuilder();

		Document doc = dBuilder.parse(fXmlFile);
		doc.getDocumentElement().normalize();
		
		return doc.getElementsByTagName(cloneSet);
		
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static HashMap<Integer, String> createFileList(NodeList list) {
		HashMap<Integer, String> fileMap = new HashMap<Integer, String>();
		
		int file = 0;
		while(file < list.getLength()) { //Jede Node mit dem String FILE
			
			int fileID = 0;
			String fileLoc = "";
			
			int child = 0;
			NodeList fList = list.item(file).getChildNodes();
			while(child < fList.getLength()) {		//Alle Kindernoten berprfen, wenn FILEID oder FILEPATH --> relevant
				
				Node currentNode = fList.item(child);
				if(currentNode.toString().equals("[FILEID: null]"))
					fileID = Integer.valueOf(currentNode.getTextContent());
				else if(currentNode.toString().equals("[FILEPATH: null]"))
					fileLoc = currentNode.getTextContent();
				
				child++;
			}
			
			fileMap.put(fileID, fileLoc);	//FILEID und FILEPATH speichern
			file++;
		}
		return fileMap;
	}
}
